/sbin/hwclock is supposed to fall back to using /dev/rtc0 if /dev/rtc isn't
working (which it isn't, because mkinitrd creates it with the old device
numbers, and we're switching to the new RTC_CLASS driver).
Unfortunately, it'll only cope if the error it gets is ENOENT (i.e. the device
node doesn't exist). It doesn't fall back to the next device in the list if the
error is ENODEV, which is what happens when the device node exists, but there's
no driver.
Signed-off-by: David Woodhouse <dwmw2@infradead.org>
Signed-off-by: Karel Zak <kzak@redhat.com>
for (p=fls; *p; ++p) {
int fd = open(*p, O_RDONLY);
- if (fd < 0 && errno == ENOENT)
+ if (fd < 0 && (errno == ENOENT || errno == ENODEV))
continue;
rtc_dev_name = *p;
return fd;